<script setup lang="ts">
  defineEmits(['close']);

  const stylingMapping = {
    default: 'py-2 px-4 rounded-md',
    type: {
      toast: ' bg-background shadow-5',
      inline: {
        default: {
          content: 'bg-background-raised',
          closeBtn: '',
        },
        info: {
          content: 'bg-background-raised',
          closeBtn: '',
        },
        error: {
          content: 'bg-crimson-50',
          closeBtn: 'hover:!bg-crimson-100 active:!bg-crimson-200',
        },
        success: {
          content: 'bg-emerald-50',
          closeBtn: 'hover:!bg-emerald-100 active:!bg-emerald-200',
        },
        warning: {
          content: 'bg-pumpkin_spice-50',
          closeBtn: 'hover:!bg-pumpkin_spice-100 active:!bg-pumpkin_spice-200',
        },
      },
    },
  };

  const props = withDefaults(
    defineProps<{
      type?: 'toast' | 'inline';
      variant?: 'default' | 'info' | 'error' | 'success' | 'warning';
      showCloseBtn?: boolean;
    }>(),
    {
      type: 'inline',
      variant: 'default',
      showCloseBtn: true,
    },
  );

  const computedClasses = computed(() => {
    return [
      stylingMapping.default,
      props.type === 'inline'
        ? stylingMapping.type[props.type][props.variant].content
        : stylingMapping.type[props.type],
    ];
  });

  const closeBtnClasses = computed(() => {
    return [props.type === 'inline' && stylingMapping.type[props.type][props.variant].closeBtn];
  });
</script>

<template>
  <div :class="computedClasses">
    <div class="flex items-center justify-between gap-2">
      <div v-if="props.variant !== 'default'">
        <span
          v-if="props.variant === 'info'"
          class="i-sw-solid:info-circle text-primary text-base"
        />
        <span
          v-if="props.variant === 'error'"
          class="i-sw-solid:exclamation-circle text-crimson-500 text-base"
        />
        <span
          v-if="props.variant === 'success'"
          class="i-sw-solid:check-circle text-base text-emerald-700"
        />
        <span
          v-if="props.variant === 'warning'"
          class="i-sw-solid:exclamation-triangle text-pumpkin_spice-500 text-base"
        />
      </div>
      <span class="text-sm font-medium">
        <slot></slot>
      </span>

      <div class="ml-4 flex gap-2">
        <slot name="action" />

        <button
          v-if="showCloseBtn"
          :class="[
            closeBtnClasses,
            'hover:bg-interactive-hover active:bg-interactive-pressed ml-auto rounded-md transition',
          ]"
          @click="$emit('close')"
        >
          <span class="i-sw-regular:times-xs" />
        </button>
      </div>
    </div>
  </div>
</template>
